"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.register = exports.resetModels = exports.registerModel = exports.getModel = exports.query = exports.start = exports.init = void 0;

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _hooks = require("@forrestjs/hooks");

var _serviceLogger = require("@forrestjs/service-logger");

var _hooks2 = require("./hooks");

var _init = _interopRequireDefault(require("./init"));

exports.init = _init.default;

var _start = _interopRequireDefault(require("./start"));

exports.start = _start.default;

var _query = _interopRequireDefault(require("./query"));

exports.query = _query.default;

var _conn = require("./conn");

exports.getModel = _conn.getModel;
exports.registerModel = _conn.registerModel;
exports.resetModels = _conn.resetModels;

const register = ({
  registerAction,
  createHook
}) => {
  registerAction({
    hook: _hooks.INIT_SERVICE,
    name: '→ postgres',
    trace: __filename,
    handler: function () {
      var _handler = (0, _asyncToGenerator2.default)(function* ({
        postgres
      }) {
        if (!postgres) {
          (0, _serviceLogger.logError)(`[postgres] missing boot configuration`);
          throw new Error(`[postgres] missing boot configuration`);
        }

        for (var _iterator = postgres, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
          var _ref;

          if (_isArray) {
            if (_i >= _iterator.length) break;
            _ref = _iterator[_i++];
          } else {
            _i = _iterator.next();
            if (_i.done) break;
            _ref = _i.value;
          }

          const options = _ref;
          const name = `${_hooks2.POSTGRES_BEFORE_INIT}/${options.connectionName || 'default'}`;
          createHook(name, {
            args: {
              options
            }
          });
          yield (0, _init.default)(options);
        }
      });

      function handler(_x) {
        return _handler.apply(this, arguments);
      }

      return handler;
    }()
  });
  registerAction({
    hook: _hooks.START_SERVICE,
    name: '→ postgres',
    trace: __filename,
    handler: function () {
      var _handler2 = (0, _asyncToGenerator2.default)(function* ({
        postgres
      }) {
        for (var _iterator2 = postgres, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
          var _ref2;

          if (_isArray2) {
            if (_i2 >= _iterator2.length) break;
            _ref2 = _iterator2[_i2++];
          } else {
            _i2 = _iterator2.next();
            if (_i2.done) break;
            _ref2 = _i2.value;
          }

          const options = _ref2;
          const name = `${_hooks2.POSTGRES_BEFORE_START}/${options.connectionName || 'default'}`;
          createHook(name, {
            args: {
              options
            }
          });
          yield (0, _start.default)(options);
        }
      });

      function handler(_x2) {
        return _handler2.apply(this, arguments);
      }

      return handler;
    }()
  });
};

exports.register = register;