"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _sequelize = _interopRequireDefault(require("sequelize"));

var _serviceLogger = require("@forrestjs/service-logger");

var _conn = require("./conn");

var _default = config => {
  (0, _serviceLogger.logInfo)('[postgres] init');
  const name = config.connectionName || 'default';
  const handler = new _sequelize.default(config.database, config.username, config.password, {
    dialect: 'postgres',
    host: config.host,
    port: config.port,
    logging: config.logging || _serviceLogger.logDebug,
    operatorsAliases: {}
  });
  (0, _conn.addHandler)(name, {
    name,
    config,
    handler
  });
};

exports.default = _default;